<?php

/**
 * Wireless AP controller.
 *
 * @category   Apps
 * @package    Wireless_AP
 * @subpackage Views
 * @author     Todd Lewis <todd@grizzlystar.com> 
 * @copyright  2019 Todd Lewis
 * @license    GPLv3
 */

///////////////////////////////////////////////////////////////////////////////
// C L A S S
///////////////////////////////////////////////////////////////////////////////

/**
 * Wireless AP controller.
 *
 * @category   Apps
 * @package    Wireless_AP
 * @subpackage Controllers
 * @author     Todd Lewis <todd@grizzlystar.com> 
 * @copyright  2019 Todd Lewis
 * @license    GPLv3
 */

class Wireless_ap extends ClearOS_Controller
{
    /**
     * Wireless AP default controller.
     *
     * @return view
     */

    function index()
    {
        // Load dependencies
        //------------------

        $this->lang->load('wireless_ap');

        // Load views
        //-----------

        $views = array('wireless_ap/server', 'wireless_ap/settings');

        $this->page->view_forms($views, lang('wireless_ap_app_name'));
    }
}
