<?php

/**
 * Javascript helper for Wireless.
 *
 * @category   apps
 * @package    wireless
 * @subpackage javascript
 * @author     Todd Lewis <todd@grizzlystar.com> 
 * @copyright  2019 Todd Lewis
 * @license    GPLv3
 */

///////////////////////////////////////////////////////////////////////////////
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
//
///////////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////////
// B O O T S T R A P
///////////////////////////////////////////////////////////////////////////////

$bootstrap = getenv('CLEAROS_BOOTSTRAP') ? getenv('CLEAROS_BOOTSTRAP') : '/usr/clearos/framework/shared';
require_once $bootstrap . '/bootstrap.php';

clearos_load_language('wireless_ap');

header('Content-Type: application/x-javascript');
?>

var lang_passphrase = '<?php echo lang('wireless_ap_passphrase'); ?>';
var lang_radius_secret = '<?php echo lang('wireless_ap_radius_secret'); ?>';

function showSelection(option, $options){
    $.each($options, function(index, value){
        var $v = $(value);
        if ($v.attr('value') && $v.attr('value') === option){
            $v.show();
        }
    });
}

function showSelection_array(options, $options){
    $.each(options, function(index,value0){
        var _value0 = value0;
        $.each($options, function(index, value){
            var $v = $(value);
            if ($v.attr('value') && $v.attr('value') === _value0){
                $v.show();
            }
                
        });
    });
}

function handle_form_data (el){

    var val = $(el).val();
    var channels = $('.channels');
    var channel_g = $('#channel_g').val();
    var channel_a = $('#channel_a').val();
    var channel_dfs = $('#channel_dfs').val();
    var hw_mode = $('#hw_mode').val();
    var ieee80211n = $('#ieee80211n').val();
    var vht_oper_chwidth = $('#vht_oper_chwidth').val();
    var acs_exclude_dfs = $('#acs_exclude_dfs').val();
    
    $('#channel_g_field').hide();
    $('#channel_a_field').hide();
    $('#channel_dfs_field').hide();
    
    $('#channel_mutiselect_form_g').hide();
    $('#channel_mutiselect_form_a').hide();
    $('#channel_mutiselect_form_dfs').hide();

    $('#ieee80211ac_field').hide();
    $('#vht_oper_chwidth_field').hide();
    $('#require_ht_field').hide();
    $('#acs_exclude_dfs_field').hide();
    $('#spectrum_mgmt_required_field').hide(); 
    $('#local_pwr_constraint_field').hide();
    $('#channel_mutiselect_form').hide();

    $('#channel_mutiselect_001').hide();
    $('#channel_mutiselect_002').hide();
    $('#channel_mutiselect_003').hide();
    $('#channel_mutiselect_004').hide();
    $('#channel_mutiselect_005').hide();
    $('#channel_mutiselect_006').hide();
    $('#channel_mutiselect_007').hide();
    $('#channel_mutiselect_008').hide();
    $('#channel_mutiselect_009').hide();
    $('#channel_mutiselect_010').hide();
    $('#channel_mutiselect_011').hide();
    $('#channel_mutiselect_012').hide();
    $('#channel_mutiselect_013').hide();
    $('#channel_mutiselect_014').hide();
    $('#channel_mutiselect_036').hide();
    $('#channel_mutiselect_040').hide();
    $('#channel_mutiselect_044').hide();
    $('#channel_mutiselect_048').hide();
    $('#channel_mutiselect_052').hide();
    $('#channel_mutiselect_056').hide();
    $('#channel_mutiselect_060').hide();
    $('#channel_mutiselect_064').hide();
    $('#channel_mutiselect_100').hide();
    $('#channel_mutiselect_104').hide();
    $('#channel_mutiselect_108').hide();
    $('#channel_mutiselect_112').hide();
    $('#channel_mutiselect_116').hide();
    $('#channel_mutiselect_120').hide();
    $('#channel_mutiselect_124').hide();
    $('#channel_mutiselect_128').hide();
    $('#channel_mutiselect_132').hide();
    $('#channel_mutiselect_136').hide();
    $('#channel_mutiselect_140').hide();
    $('#channel_mutiselect_144').hide();
    $('#channel_mutiselect_149').hide();
    $('#channel_mutiselect_153').hide();
    $('#channel_mutiselect_157').hide();
    $('#channel_mutiselect_161').hide();
    $('#channel_mutiselect_165').hide();

    $('#channel_g option').hide();
    $('#channel_a option').hide();
    $('#channel_dfs option').hide();
    showSelection('automatic', $('#channel option'));


    if ( ieee80211n === '1' ){
        $('#vht_oper_chwidth_field').show();    
    } 

    // Channel selection can be done 2 ways. You can choose the base frequency and then allocate bandwidth
    // above or below the channel. We will assume that will always allocate bandwidth above the channel 
    if ( hw_mode === 'g' ){
        var arr = ['Automatic','1','2','3','4','5','6','7','8','9'];
        
        $('#channel_g_field').show();
        $('#channel_mutiselect_form_g').show();
        
        // These channels will be avalaable at 20Mhz and 40Mhz
        $('#channel_mutiselect_001').show();
        $('#channel_mutiselect_002').show();
        $('#channel_mutiselect_003').show();
        $('#channel_mutiselect_004').show();
        $('#channel_mutiselect_005').show();
        $('#channel_mutiselect_006').show();
        $('#channel_mutiselect_007').show();
        $('#channel_mutiselect_008').show();
        $('#channel_mutiselect_009').show();
        
        //These Channels are avialble at  20MHz
        if ( ieee80211n === '0' ){
            arr.push('10' ,'11','12','13','14');
            $('#channel_mutiselect_010').show();
            $('#channel_mutiselect_011').show();
            $('#channel_mutiselect_012').show();
            $('#channel_mutiselect_013').show();
        }         

        if ( channel_g === 'Automatic')
            $('#channel_mutiselect_form').show();

        showSelection_array(arr, $('#channel_g option'));

    } 
    
    // Build a list of all the items shown with hw_mode = a 
    if ( hw_mode === 'a' ){
        
        // Spectrum management and power constraint is only realavent if 
        // ieee80211n = 0 -> 20MHz, ieee80211n = -> 40MHz 
        // ieee80211n = 1 & vht_oper_chwidth =1 -> 80MHz 
        // acs_exclude_dfs =0 -> Use Weather Radar Channels
        // acs_exclude_dfs =1 -> Do Not Use Weather Radar Channels
        
        $('#acs_exclude_dfs_field').show();

        if ( ieee80211n === '1' )
            $('#ieee80211ac_field').show(); 
                
        // Channels Automatic, 36, and 149 are alaways shown.
        // These are non-radar channels valid with bandwidths of 80MHz,40MHz,20MHz
        var arr = ['Automatic','36','149'];
        $('#channel_mutiselect_036').show();
        $('#channel_mutiselect_149').show();

        // These are radar channels valid with bandwidths of 80MHz,40MHz,20MHz
        if (acs_exclude_dfs === '0'){
            arr.push('52','100','116','132');
            $('#channel_mutiselect_052').show();
            $('#channel_mutiselect_100').show();
            $('#channel_mutiselect_116').show();
            $('#channel_mutiselect_132').show();
        }

        // These are non-radar channels valid with bandwidths of 40MHz,20MHz
        if (vht_oper_chwidth === '0' ){
            arr.push('44', '157');
            $('#channel_mutiselect_044').show();
            $('#channel_mutiselect_157').show();
        }
            
        
        // These are radar channels valid with bandwidths of 40MHz,20MHz
        if (vht_oper_chwidth === '0' && acs_exclude_dfs === '0' ){
            arr.push('60', '108','124','140');
            $('#channel_mutiselect_060').show();
            $('#channel_mutiselect_108').show();
            $('#channel_mutiselect_124').show();
            $('#channel_mutiselect_140').show();
        }
            
        
        // These are non-radar channels valid with bandwidths of 20MHz
        if  ( ieee80211n === '0' ){
            arr.push('40','48', '153','161','165');
            $('#channel_mutiselect_040').show();
            $('#channel_mutiselect_048').show();
            $('#channel_mutiselect_153').show();
            $('#channel_mutiselect_161').show();
            $('#channel_mutiselect_165').show();
        }
            
        
        // These are radar channels valid with bandwidths of 20MHz
        if  (ieee80211n === '0'  && acs_exclude_dfs === '0' ){
            arr.push('56','64','104','112','120','128','136','144');
            $('#channel_mutiselect_056').show();
            $('#channel_mutiselect_064').show();
            $('#channel_mutiselect_104').show();
            $('#channel_mutiselect_112').show();
            $('#channel_mutiselect_120').show();
            $('#channel_mutiselect_128').show();
            $('#channel_mutiselect_136').show();
            $('#channel_mutiselect_144').show();
        }
            

        
    }

    // Take the list that was built for hw_mod = a and show the items 

    if ( hw_mode === 'a' & acs_exclude_dfs === '0' ){
        
        $('#channel_dfs_field').show();
        
        if ( channel_dfs === 'Automatic')
            $('#channel_mutiselect_form').show();
        
        showSelection_array(arr, $('#channel_a option'));
    
    } else if ( hw_mode === 'a') {
        
        $('#channel_a_field').show();
        $('#spectrum_mgmt_required_field').show();
        $('#local_pwr_constraint_field').show();

        showSelection_array(arr, $('#channel_dfs option'));
    
    } 

}

$(document).ready(function() {
    $('#wireless_ap_form_end').ready(function(e){
        handle_form_data ($('body')[0]);
    });

    $('#wpa_key_mgmt').on('change', function(e) {
        if ($('#wpa_key_mgmt').val() == 'WPA-PSK')
            $('#wpa_passphrase_label').html(lang_passphrase);  
        else
            $('#wpa_passphrase_label').html(lang_radius_secret);  
    });

    $('body').off('change', '#interface');
    $('body').on('change','#interface', function(e){
        var val = $(this).val();
        var $interface_container = $('.interface_container');
        if (val === 'Disabled'){
            $interface_container.hide();
        }
        else {
            $interface_container.show();
        }
    });

    $('body').off('change', '');
    $('body').on('change','', function(e){
        handle_form_data (this);
    });


});

// vim: ts=4 syntax=javascript